<template>
  <div class="order-list">
    <Toolbar :handle-add="addHandler" />

    <v-container grid-list-xl fluid>
      <v-layout row wrap>
        <v-flex sm12>
          <h1>Order List</h1>
        </v-flex>
        <v-flex lg12>
          <DataFilter :handle-filter="onSendFilter" :handle-reset="resetFilter">
            <OrderFilterForm
              ref="filterForm"
              :values="filters"
              slot="filter"
            />
          </DataFilter>

          <br />

          <v-data-table
            v-model="selected"
            :headers="headers"
            :items="items"
            :items-per-page.sync="options.itemsPerPage"
            :loading="isLoading"
            :loading-text="$t('Loading...')"
            :options.sync="options"
            :server-items-length="totalItems"
            class="elevation-1"
            item-key="@id"
            show-select
            @update:options="onUpdateOptions"
          >
                <template slot="item.totalPrice" slot-scope="{ item }">
                  {{ $n(item['totalPrice']) }}
                </template>
                <template slot="item.createdAt" slot-scope="{ item }">
                  {{ formatDateTime(item['createdAt'], 'long') }}
                </template>
                <template slot="item.updatedAt" slot-scope="{ item }">
                  {{ formatDateTime(item['updatedAt'], 'long') }}
                </template>
                <template slot="item.composes" slot-scope="{ item }">
                  <ul>
                    <li v-for="_item in item['composes']" :key="_item.id">
                      {{ _item.id }}
                    </li>
                  </ul>
                </template>

            <ActionCell
              slot="item.action"
              slot-scope="props"
              :handle-show="() => showHandler(props.item)"
              :handle-edit="() => editHandler(props.item)"
              :handle-delete="() => deleteHandler(props.item)"
            ></ActionCell>
          </v-data-table>
        </v-flex>
      </v-layout>
    </v-container>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex';
import { mapFields } from 'vuex-map-fields';
import ListMixin from '../../mixins/ListMixin';
import ActionCell from '../../components/ActionCell';
import OrderFilterForm from '../../components/order/Filter';
import DataFilter from '../../components/DataFilter';
import Toolbar from '../../components/Toolbar';

export default {
  name: 'OrderList',
  servicePrefix: 'Order',
  mixins: [ListMixin],
  components: {
    Toolbar,
    ActionCell,
    OrderFilterForm,
    DataFilter
  },
  data() {
    return {
      headers: [
        { text: 'totalPrice', value: 'totalPrice' },
        { text: 'renter', value: 'renter' },
        { text: 'createdAt', value: 'createdAt' },
        { text: 'updatedAt', value: 'updatedAt' },
        { text: 'composes', value: 'composes' },
        {
          text: 'Actions',
          value: 'action',
          sortable: false
        }
      ],
      selected: []
    };
  },
  computed: {
    ...mapGetters('order', {
      items: 'list'
    }),
    ...mapFields('order', {
      deletedItem: 'deleted',
      error: 'error',
      isLoading: 'isLoading',
      resetList: 'resetList',
      totalItems: 'totalItems',
      view: 'view'
    })
  },
  methods: {
    ...mapActions('order', {
      getPage: 'fetchAll',
      deleteItem: 'del'
    })
  }
};
</script>
